import java.util.Scanner;


public class HangMan {
	
	public static int range(int s, int e)
	{
		return (int) (Math.random() * (e-s+1) ) + s;
	}
	public static boolean isPrime(int x)
	{
		for(int i = 2; i <= Math.sqrt(x); i ++)
		{
			if( (x % i) == 0 )
				return false;
		}
		return true;
	}
	public static String choose(String[] dict)
	{
		int  n = range(10, 100);
		if(!isPrime(n))
			return pick(dict);
		else
			return generate();
	}
	public static String pick(String[] dict)
	{
		int k = range(0, dict.length - 1);
		return dict[k];
	}
	public static String generate()
	{
		int size 	= range(1, 10);
		int space	= range(0, 1);
		String result 	= "";
		String res  	= "";
		for(int i = 0; i < size; i++)
		{
			int idx 	= range(0, 25);
			char letter = (char) ('a' + idx);
			result 		+= letter;
		}
		if(space == 1)
		{
			int idx = range(0, size - 1);
			for(int i = 0; i < size; i++)
			{
				if(i == idx)
					res += ' ';
				else
					res += result.charAt(i);
			}
			return res;
		}
		else 
			return result;
		
	}
	public static String getMask(String s)
	{
		String res = "";
		for(int i = 0; i < s.length();  i ++)
		{
			if(s.charAt(i) != ' ')
				res += '*';
			else
				res += s.charAt(i);
		}
		return res;
	}
	public static boolean alreadyGuessed(String mask, char c)
	{
		return (mask.indexOf(c) >= 0);
	}
	public static String reveal(String clear, String mask, char c)
	{
		String newMask = "";
		for(int i = 0; i < clear.length(); i++)
		{
			if(clear.charAt(i) == c)
				newMask += c;
			else
				newMask += mask.charAt(i);
		}
		return newMask;
	}
	public static char ask(Scanner input, String mask)
	{
		System.out.print("(Guess) Enter a letter in word " + mask + " > ");
		String line = input.next();
		input.nextLine();
		return line.charAt(0);
	}
	public static String round(Scanner scan, String[] dict)
	{
		String toGuess 	= choose(dict);
		String mask	 	= getMask(toGuess);
		int miss 		= 0;
		while(mask.equals(toGuess) == false)
		{
			char g = ask(scan, mask);
			if(alreadyGuessed(mask, g))
			{
				System.out.println(g + " is already in the word");
			}
			else
			{
				String newMask = reveal(toGuess, mask, g);
				if(newMask.equals(mask))
				{
					System.out.println(g + " is not in the word");
					miss++;
				}
				else
					mask = newMask;
			}
		}
		System.out.println("The word is " + toGuess + ". You missed " + miss + " time");
		return toGuess;
	}
	public static String[] update(String[] dict, String current)
	{
		if(inDictionary(dict, current) == false)
			return dict;
		else
		{
			String[] newDict = new String[dict.length - 1];
			int k = 0;
			for(int i = 0; i < dict.length; i++)
			{
				if(dict[i].equals(current) == false)
				{
					newDict[k] = dict[i];
					k++;
				}
			}
			return newDict;
		}
			
	}
	public static boolean inDictionary(String[] dict, String word)
	{
		for(int i = 0; i < dict.length; i++)
			if(dict[i].equals(word))
				return true;
		return false;
	}
	public static void main(String[] args)
	{
		boolean keepasking = true;
		String[] dict = {"I", "love", "this", "course", 
				"tremendously", "it is the", "best course ever" };
		
		Scanner input = new Scanner(System.in);
		String another;
		while(keepasking)
		{
			String answer = round(input, dict);
			dict = update(dict, answer);
			
			System.out.println();
			System.out.println("Do you want to guess for another word? Enter y or n> ");
			another = input.nextLine();
			if(another.charAt(0) == 'n')
				keepasking = false;
		}
		
	}
}
